#ifndef lint
static char SCCSidI[] = "@(#) ./comm/initnx.c 12/01/93";
#endif

/*
    Intel-NX specific routines
 */
int  __NXFROM, __NXLEN;

/*
    exitall - terminate all processes in an execution (parallel exit)
    See init.c for a complete description of the interface
 */
static void nxexitall(msg,rc)
char *msg;
int  rc;
{
killproc( -1, 0 );
}

#define PI_HAS_PIINIT
void PIinit()
{
#if defined(inteldelta)
{ 
int nx, ny;
mypart( &nx, &ny );
PISetMeshSize( nx, ny );
}
PISetNbrRoutine( PIGetNbrsMSH );

/* Strangely enough, the paragon provides no access to the partition shape */
#elif defined(intelparagon)
{ 
int nx;
nx = nodedim();
PISetMeshSize( nx, 1 );
}
PISetNbrRoutine( PIGetNbrsMSH );
#else
PISetDim( nodedim() );
PISetNbrRoutine( PIGetNbrsHC );
#endif
PISetupCollectiveTree( );
}

int PIcall( np, procgroup, pfname, routine, argc, argv )
int  np, argc;
char **procgroup, *pfname;
char **argv;
int  (*routine)();
{
int rc;

SYSetExitAll(nxexitall);
#if !defined(LOGCOMMDISABLE)
PIGetDebugArgs( &argc, argv, mynode() == 0 );
#endif

/* Initialize the communications (particularly the collective operations) */
PIinit();

PIinitlog( );
PISummaryClear();
rc = (*routine)( argc, argv );
PIendlog();
return rc;
}

#define PI_HAS_EXIT
#define PI_HAS_INIT

int PInxIprobe( type )
int type;
{
int rc;

rc       = iprobe(type);
if (rc) {
    __NXFROM = infonode();
    __NXLEN  = infocount();
    }

return rc;
}

#define PI_HAS_NODENAME
#include <sys/types.h>
#if !defined(intelparagon)
#include <nxinfo.h>
#define PHYNODE() nxinfo.physnode
#else
#define PHYNODE() PImytid
#endif

void PINodeName( name, maxlen )
char *name;
int  maxlen;
{
char b1[20];
sprintf( b1, "%d", PHYNODE() );
strncpy( name, b1, maxlen );
}
